#############################################################################
# burn.tcl Copyright 2004, 2005 r0lZ
# DVD Burn stuff, using mkisofs.exe and DVD Decrypter.
#
# This file is part of PgcEdit.
#
# PgcEdit is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# PgcEdit is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#############################################################################

if {$::tcl_platform(platform) == "windows"} {
namespace eval ::burn {

proc setup {} {
	set utiltitle "PgcEdit: Burn DVD - Setup"
	set w .burnsetup
	if [winfo exists $w] {bell; return}
	toplevel $w -class Dialog
	wm withdraw $w
	wm title $w $utiltitle
	wm transient $w .burn
	if {$::tcl_platform(platform) == "windows"} {catch {wm attributes $w -toolwindow 1}}
	wm protocol $w WM_DELETE_WINDOW {set ::burn::setup_done 0}
	bind $w <Escape> "set ::burn::setup_done 0"

	frame  $w.f1 -bd 2 -relief groove
	pack   $w.f1 -fill x -padx 4 -pady 2
	label  $w.f1.lab -text "Required :  mkisofs.exe is part of ImgTools Classic (not ImgTools Burn!)"
	pack   $w.f1.lab -side top -anchor w
	frame  $w.f1.f
	pack   $w.f1.f -fill x -pady 2 -anchor w
	label  $w.f1.f.lab -text "Path to mkisofs.exe:"
	pack   $w.f1.f.lab -side left
	entry  $w.f1.f.mkisofs -textvariable ::burn::tmp_mkisofspath
	pack   $w.f1.f.mkisofs -side left -fill x -expand 1 -padx 2
	button $w.f1.f.browse -text "..." -pady 0 -command "set tmp \[tk_getOpenFile -filetypes {{{Program files} {*.EXE}}} -initialdir [file dirname \"\$::burn::tmp_mkisofspath\"] -initialfile [file tail \"\$::burn::tmp_mkisofspath\"] -parent $w -title {Burn DVD: mkisofs.exe path}\]; if {\$tmp != {}} {set ::burn::tmp_mkisofspath \[file nativename \$tmp\]}"
	pack   $w.f1.f.browse -side left -fill y -padx 2
	button $w.f1.dl -text "Download ImgTools Classic (free)" -width 32 -pady 0 -command {
		catch {exec -- $::config(web_browser) \
		"http://www.coujo.de/ib/index.php?act=html_include&incl_name=download" &}}
	pack   $w.f1.dl -padx 2 -pady 2

	frame  $w.f2 -bd 2 -relief groove
	pack   $w.f2 -fill x -padx 4 -pady 2
	label  $w.f2.lab -text "Optional:  Allow to burn the ISO image with DVD Decrypter"
	pack   $w.f2.lab -side top -anchor w
	frame  $w.f2.f
	pack   $w.f2.f -fill x -pady 2 -anchor w
	label  $w.f2.f.lab1 -text "Path to DVDDecrypter.exe:"
	pack   $w.f2.f.lab1 -side left
	entry  $w.f2.f.dvdd -textvariable ::burn::tmp_dvddecrypterpath
	pack   $w.f2.f.dvdd -side left -fill x -expand 1 -padx 2
	button $w.f2.f.browse -text "..." -pady 0 -command "set tmp \[tk_getOpenFile -filetypes {{{Program files} {*.EXE}}} -initialdir [file dirname \"\$::burn::tmp_dvddecrypterpath\"] -initialfile [file tail \"\$::burn::tmp_dvddecrypterpath\"] -parent $w -title {Burn DVD: DVDDecrypter.exe path}\]; if {\$tmp != {}} {set ::burn::tmp_dvddecrypterpath \[file nativename \$tmp\]}"
	pack   $w.f2.f.browse -side left -fill y -padx 2
	button $w.f2.dl -text "Download DVD Decrypter (free)" -width 32 -pady 0 -command {
		catch {exec -- $::config(web_browser) \
		"http://www.dvddecrypter.com/index.php?act=download" &}}
	pack   $w.f2.dl -padx 2 -pady 2

	frame  $w.f4 -bd 2 -relief groove
	pack   $w.f4 -fill x -padx 4 -pady 2
	label  $w.f4.lab -text "Optional :  Allow to mount the ISO image with Daemon-Tools\n(Doesn't work when the Split ISO image option below is checked)" -justify left
	pack   $w.f4.lab -side top -anchor w
	frame  $w.f4.f
	pack   $w.f4.f -fill x -pady 2 -anchor w
	label  $w.f4.f.lab1 -text "Path to daemon.exe:"
	pack   $w.f4.f.lab1 -side left
	entry  $w.f4.f.dvdd -textvariable ::burn::tmp_daemonpath
	pack   $w.f4.f.dvdd -side left -fill x -expand 1 -padx 2
	button $w.f4.f.browse -text "..." -pady 0 -command "set tmp \[tk_getOpenFile -filetypes {{{Program files} {*.EXE}}} -initialdir [file dirname \"\$::burn::tmp_daemonpath\"] -initialfile [file tail \"\$::burn::tmp_daemonpath\"] -parent $w -title {Burn DVD: DVDDecrypter.exe path}\]; if {\$tmp != {}} {set ::burn::tmp_daemonpath \[file nativename \$tmp\]}"
	pack   $w.f4.f.browse -side left -fill y -padx 2
	button $w.f4.dl -text "Download Daemon-Tools (free)" -width 32 -pady 0 -command {
		catch {exec -- $::config(web_browser) \
		"http://www.daemon-tools.cc/dtcc/portal/download.php?mode=ViewCategory&catid=5" &}}
	pack   $w.f4.dl -padx 2 -pady 2

	checkbutton $w.split -variable ::burn::tmp_splitoutput -anchor w -onvalue "-split-output" -offvalue "" \
			-text "Split ISO image into 1GB chunks - Required for FAT32 partitions (Win95/98/ME)!"
	pack   $w.split -fill x -pady 2

	frame  $w.f3
	pack   $w.f3 -fill x -padx 2 -pady 2
	label  $w.f3.lab1 -text "DVD Burner drive letter: " -anchor w
	pack   $w.f3.lab1 -side left
	tk_optionMenu $w.f3.mb ::burn::tmp_burnerletter D: E: F: G: H: I: J: K: L: M: N: O: P: Q: R: S: T: U: V: W: X: Y: Z:
	pack   $w.f3.mb -side left

	# buttons
	frame  $w.fb
	pack   $w.fb -padx 2 -pady 4 -anchor e
	button $w.fb.ok -text "Save" -width 10 -command {set ::burn::setup_done 1}
	pack   $w.fb.ok -side left -padx 2
	button $w.fb.cancel -text "Cancel" -width 10 -command {set ::burn::setup_done 0}
	pack   $w.fb.cancel -side left -padx 2

	set ::burn::tmp_mkisofspath [file nativename $::burn::mkisofspath]
	set ::burn::tmp_dvddecrypterpath [file nativename $::burn::dvddecrypterpath]
	set ::burn::tmp_daemonpath [file nativename $::burn::daemonpath]
	set ::burn::tmp_splitoutput $::burn::splitoutput
	set ::burn::tmp_burnerletter $::burn::burnerletter

	update
	wm minsize $w [winfo reqwidth $w] [winfo reqheight $w]
	wm maxsize $w [winfo reqwidth $w] [winfo reqheight $w]
	set wx [expr [winfo rootx .]+(([winfo width  .]-[winfo reqwidth  $w])/2)]
	set wy [expr [winfo rooty .]+(([winfo height .]-[winfo reqheight $w])/2)-25]
	if {$wx < 10} {set wx 10}
	if {$wy < 10} {set wy 10}
	wm geometry $w +$wx+$wy
	wm deiconify $w
	focus $w
	grab set $w

	tkwait variable ::burn::setup_done
	grab release $w
	destroy $w
	#grab set .burn

	if {$::burn::setup_done} {
		set ::burn::mkisofspath $::burn::tmp_mkisofspath
		set ::burn::dvddecrypterpath $::burn::tmp_dvddecrypterpath
		set ::burn::daemonpath $::burn::tmp_daemonpath
		set ::burn::splitoutput $::burn::tmp_splitoutput
		set ::burn::burnerletter $::burn::tmp_burnerletter
		validate_burn
		save_setups
	}
}

proc burn {} {
	if {! [info exists ::dvddir]} {bell; return}
	if {[info exists ::burn::processing] && $::burn::processing} {bell; return}
	set ::burn::processing false

	if $::dvd_modified {
		set r [tk_messageBox -title "PgcEdit: Burn DVD" -icon warning \
				-message "DVD modified but not saved!\n\nThe DVD will be burned with the\nfiles currently saved on disk.\n\nContinue?" \
				-parent . -type yesno -default no]
		if {$r == "no"} {
			return
		}
		set dvdmodifiedwarning "\n\nWarning: DVD modified but not saved!"
	} else {
		set dvdmodifiedwarning ""
	}

	set in [file nativename [file normalize $::dvddir]]
	if {[file tail $in] == "VIDEO_TS"} {
		set in [file dirname $in]
	} else {
		set txt "WARNING: The DVD files must be in a VIDEO_TS subfolder.\n\n"
		set txt "${txt}Do you want to move the DVD files (and the PgcEdit_backup)\n"
		set txt "${txt}in a new VIDEO_TS subfolder, and reload the DVD?"
		set txt "${txt}$dvdmodifiedwarning"
		set r [tk_messageBox -title "PgcEdit: Burn DVD" -icon warning \
				-message $txt -parent . -type yesno -default yes]
		if {$r == "no"} {
			::macros::explore_dvd
			return
		} else {
			set files [glob -tails -directory "$::dvddir" V*TS*]
			set newdir [file join $::dvddir VIDEO_TS]
			if [catch {file mkdir $newdir} errstr] {
				tk_messageBox -title "PgcEdit: Burn DVD" -icon error \
						-message "Sorry: $errstr" -parent . -type ok
				::macros::explore_dvd
				return
			}
			foreach f $files {
				if [catch {file rename -- [file join $::dvddir $f] $newdir} errstr] {
					tk_messageBox -title "PgcEdit: Burn DVD" -icon error \
							-message "Sorry: $errstr" -parent . -type ok
					::macros::explore_dvd
					return
				}
			}
			catch [file rename -- [file join $::dvddir PgcEdit_backup] $newdir]
			set ::dvddir $newdir
			::main::ReRead_DVD
			burn
			return
		}
	}
	set in [file nativename [file normalize $in]]

	set id [::utils::get_General_Name]
	if {$id == ""} {
		set vname [file tail $::dvddir]
		if {$vname == "VIDEO_TS"} {
			set vname [file tail [file dirname $::dvddir]]
		}
		set id $vname
	}
	set id2 ""
	set underscore true
	for {set i 0} {$i < 32} {incr i} {
		set c [string range $id $i $i]
		if [string is alnum $c] {
			set id2 $id2$c
			set underscore false
		} else {
			if {! $underscore} {
				set id2 ${id2}_
			}
			set underscore true
		}
	}
	set ::burn::id [string range [string toupper [string trim $id2 _]] 0 31]
	set ::burn::status ""

	set ::burn::out [file nativename [file normalize [file join [file dirname $::burn::out] ${::burn::id}.ISO]]]

	set utiltitle "PgcEdit: Burn DVD"
	set w .burn
	if [winfo exists $w] {bell; return}
	toplevel $w -class Dialog -menu $w.setupmenu
	wm withdraw $w
	wm title $w $utiltitle
	wm transient $w .
	if {$::tcl_platform(platform) == "windows"} {catch {wm attributes $w -toolwindow 1}}
	wm protocol $w WM_DELETE_WINDOW {set ::burn::burn_done 0}
	bind $w <Escape> "set ::burn::burn_done 0"

	menu $w.setupmenu
	$w.setupmenu add command -label Setup -command ::burn::setup

	set dvdromsize [dvd_rom_size $in]
	set sectors [expr [::writedvd::DVD_sectors] + $dvdromsize]
	set txtlist [::writedvd::DVD_size_text $sectors $dvdromsize]

	set gaptext "Use 32KB gaps option is currently "
	if $::config(save_BUP_with_gaps) {
		set gaptext ${gaptext}ON
		set gaptexthighlight darkgreen
	} else {
		set gaptext ${gaptext}OFF
		set gaptexthighlight black
	}
	frame  $w.sf -bd 2 -relief groove
	pack   $w.sf -fill x -padx 4 -pady 4
	label  $w.sf.size1 -text "Space [string map {: :\n} [lindex $txtlist 0]]" -justify left
	label  $w.sf.size2 -text "Space [string map {: :\n} [lindex $txtlist 1]]" -justify left
	label  $w.sf.pc -text [lindex $txtlist 2]
	pack   $w.sf.pc -anchor w
	label  $w.sf.gap -text $gaptext
	pack   $w.sf.gap -anchor w
	grid   $w.sf.size1 -row 0 -column 0 -sticky w
	grid   $w.sf.size2 -row 0 -column 1 -sticky w
	grid   $w.sf.pc    -row 1 -column 0 -sticky w
	grid   $w.sf.gap   -row 1 -column 1 -sticky w
	grid columnconfigure $w.sf 0 -uniform 1 -weight 1
	grid columnconfigure $w.sf 1 -uniform 1 -weight 1
	if {$sectors > 2295104} {
		$w.sf.pc configure -foreground red
	}
	$w.sf.gap configure -foreground $gaptexthighlight

	frame  $w.opts -bd 2 -relief groove
	pack   $w.opts -padx 4 -pady 2
	frame  $w.opts.f2
	pack   $w.opts.f2 -fill x -padx 4 -pady 4
	label  $w.opts.f2.lab -text "Output ISO:" -width 12 -anchor w
	pack   $w.opts.f2.lab -side left
	entry  $w.opts.f2.id -width 70 -textvariable ::burn::out
	pack   $w.opts.f2.id -side left -fill x
	frame  $w.opts.f2.pad -width 4
	pack   $w.opts.f2.pad -side left
	button $w.opts.f2.browse -text "..." -pady 0 -command "set out \[tk_getSaveFile -filetypes {{{ISO Image files} {*.ISO}}} -initialdir [file dirname \"\$::burn::out\"] -initialfile [file tail \"\$::burn::out\"] -parent $w -title {Burn DVD: ISO image filename}\]; if {\$out != {}} {set ::burn::out \[file nativename \$out\]}"
	pack   $w.opts.f2.browse -side left -fill y

	frame  $w.opts.f1
	pack   $w.opts.f1 -fill x -padx 4 -pady 2
	label  $w.opts.f1.lab -text "Volume Label:" -width 12 -anchor w
	pack   $w.opts.f1.lab -side left
	entry  $w.opts.f1.id -width 32 -textvariable ::burn::id -validatecommand "::burn::validate_id_entry %P" -validate all
	pack   $w.opts.f1.id -fill x

	checkbutton $w.opts.showlog -variable ::burn::showlog -text "Always show ISO creation log  (Will be shown anyway in case of error)" \
			-anchor w -onvalue true -offvalue false
	pack   $w.opts.showlog -fill x -padx 2

	frame  $w.opts.fmount
	pack   $w.opts.fmount -fill x -padx 2
	checkbutton $w.opts.fmount.mount -variable ::burn::mount -text "Mount ISO image using Daemon-Tools, as device" \
			-anchor w -onvalue true -offvalue false -command ::burn::validate_burn
	pack   $w.opts.fmount.mount -fill x -side left
	tk_optionMenu $w.opts.fmount.device ::burn::mount_device 0 1 2 3
	pack   $w.opts.fmount.device -side left
	label  $w.opts.fmount.lab -text " (Warning : The device must be enabled!)"
	pack   $w.opts.fmount.lab -side left

	checkbutton $w.opts.burn -variable ::burn::burn -text "Burn ISO image using DVD Decrypter:" \
			-anchor w -command ::burn::validate_burn -onvalue true -offvalue false
	pack   $w.opts.burn -fill x -padx 2

	frame  $w.opts.bo -bd 2 -relief groove
	pack   $w.opts.bo -fill x -padx 24
	frame  $w.opts.bo.sp
	pack   $w.opts.bo.sp -fill x -padx 2
	label  $w.opts.bo.sp.l -text "Burn speed:"
	pack   $w.opts.bo.sp.l -side left
	tk_optionMenu $w.opts.bo.sp.speed ::burn::speed 1x 2x 2.4x 2,4x 4x 8x 12x 16x MAX
	pack   $w.opts.bo.sp.speed -side left
	checkbutton $w.opts.bo.start -variable ::burn::start -text "Start burn immediately" -anchor w -onvalue "/START" -offvalue ""
	pack   $w.opts.bo.start -fill x
	checkbutton $w.opts.bo.eraserw -variable ::burn::eraserw -text "Erase non empty RW media" -anchor w -onvalue "/ERASE" -offvalue ""
	pack   $w.opts.bo.eraserw -fill x
	checkbutton $w.opts.bo.verify -variable ::burn::verify -text "Verify written DVD" -anchor w -onvalue YES -offvalue NO
	pack   $w.opts.bo.verify -fill x
	checkbutton $w.opts.bo.del -variable ::burn::deleteimage -text "Delete ISO image when done" -anchor w -onvalue YES -offvalue NO
	pack   $w.opts.bo.del -fill x
	checkbutton $w.opts.bo.close -variable ::burn::close -text "Close DVD Decrypter when done (also in case of error!)" -anchor w -onvalue "/CLOSE" -offvalue ""
	pack   $w.opts.bo.close -fill x
	checkbutton $w.opts.bo.shutdown -variable ::burn::shutdown -text "Shutdown computer after burning (and close PgcEdit after ISO creation)" -anchor w -onvalue "/SHUTDOWN" -offvalue ""
	pack   $w.opts.bo.shutdown -fill x
	frame  $w.opts.pad -height 2
	pack   $w.opts.pad

	label  $w.status -textvariable ::burn::status
	pack   $w.status -pady 4
	canvas $w.c -width 300 -height 15 -bd 2 -relief sunken
	pack   $w.c -padx 2 -fill x

	# buttons
	frame  $w.fb
	pack   $w.fb -padx 2 -pady 4 -fill x
	button $w.fb.dt -text " Show Daemon-Tools tray icon " -command {catch {exec -- $::burn::daemonpath &}}
	pack   $w.fb.dt -side left -padx 2
	frame  $w.fb.pad -width 2
	pack   $w.fb.pad -side left -fill x -expand 1
	button $w.fb.ok -text "OK" -width 10 -command {set ::burn::burn_done 1}
	pack   $w.fb.ok -side left -padx 2
	button $w.fb.cancel -text "Cancel" -width 10 -command {set ::burn::burn_done 0}
	pack   $w.fb.cancel -side left -padx 2

	validate_burn

	update
	wm minsize $w [winfo reqwidth $w] [winfo reqheight $w]
	wm maxsize $w [winfo reqwidth $w] [winfo reqheight $w]
	set wx [expr [winfo rootx .]+(([winfo width  .]-[winfo reqwidth  $w])/2)]
	set wy [expr [winfo rooty .]+(([winfo height .]-[winfo reqheight $w])/2)-25]
	if {$wx < 10} {set wx 10}
	if {$wy < 10} {set wy 10}
	wm geometry $w +$wx+$wy
	wm deiconify $w
	focus $w
	#grab set $w

	catch {trace remove variable ::burn::out write ::burn::validate_burn}
	catch {trace remove variable ::burn::id  write ::burn::validate_burn}
	trace add variable ::burn::out write ::burn::validate_burn
	trace add variable ::burn::id  write ::burn::validate_burn

	if {![file isfile $::burn::mkisofspath]} {
		setup
	}

	# wait for user input
	set error true
	while {$error} {
		# configure burn window for input
		set ::burn::processing false
		wm protocol $w WM_DELETE_WINDOW {set ::burn::burn_done 0}
		$w.fb.ok configure -state normal
		$w.fb.cancel configure -text "Cancel" -state normal -command {set ::burn::burn_done 0}
		$w.opts.f2.lab configure -foreground [$w.fb.ok cget -foreground]
		$w.opts.f2.id configure -state normal
		$w.opts.f2.browse configure -state normal
		$w.opts.f1.lab configure -foreground [$w.fb.ok cget -foreground]
		$w.opts.f1.id configure -state normal
		catch {trace remove variable ::burn::out write ::burn::validate_burn}
		catch {trace remove variable ::burn::id  write ::burn::validate_burn}
		trace add variable ::burn::out write ::burn::validate_burn
		trace add variable ::burn::id  write ::burn::validate_burn
		#set ::burn::status "Ready."
		show_msg ""
		validate_burn
		if [info exists ::burn::progressbar_item] {
			$w.c delete $::burn::progressbar_item
		}
		set ::burn::burn_done false
		tkwait variable ::burn::burn_done
		if {!$::burn::burn_done} {
			trace remove variable ::burn::out write ::burn::validate_burn
			trace remove variable ::burn::id  write ::burn::validate_burn
			destroy $w
			return
		}

		# set internal variables
		set mkisofserror "****** ERROR returned by mkisofs! ******"
		set out $::burn::out
		set ext [string toupper [file extension $out]]
		if {$ext != ".ISO"} {
			set out ${out}.ISO
		}
		if {$::burn::splitoutput == ""} {
			set realout $out
		} else {
			set realout [file rootname $out].lst
		}
		set log [file nativename [file normalize "[file rootname $out].log"]]
		set error false

		# check for free space on disk
		if {!$error} {
			set sectorsfree [get_free_disk_space $realout]
			if {$sectorsfree < $sectors && $sectorsfree != -1} {
				set r [tk_messageBox -title "PgcEdit: Burn DVD" -icon warning \
					-message "WARNING: Not enough free space left on hard disk!\n\nContinue anyway?" \
					-parent $w -type yesno -default no]
				if {$r == "no"} {
					set error true
				}
			}
		}

		# check overwrite existing ISO
		if {!$error} {
			if [file exists $realout] {
				set r [tk_messageBox -title "PgcEdit: Burn DVD" -icon warning \
					-message "WARNING: Output ISO image already exists!\n\nOverwrite?" \
					-parent $w -type yesno -default yes]
				if {$r == "no"} {set error true}
			}		
		}

		# build list of alien files to remove from the VIDEO_TS folder
		if {!$error} {
			set alienfiles [glob -tails -directory "$in/VIDEO_TS" *]
			foreach f {VIDEO_TS.IFO VIDEO_TS.VOB VIDEO_TS.BUP} {
				set idx [lsearch $alienfiles $f]
				if {$idx != -1} {
					set alienfiles [lreplace $alienfiles $idx $idx]
				}
			}
			for {set vts 1} {$vts < 100} {incr vts} {
				set basename "VTS_[format %02d $vts]_"
				foreach f [list "${basename}0.IFO" "${basename}0.BUP"] {
					set idx [lsearch $alienfiles $f]
					if {$idx != -1} {
						set alienfiles [lreplace $alienfiles $idx $idx]
					}
				}
				for {set n 0} {$n < 10} {incr n} {
					set idx [lsearch $alienfiles "${basename}$n.VOB"]
					if {$idx != -1} {
						set alienfiles [lreplace $alienfiles $idx $idx]
					}
				}
			}
			set idx [lsearch $alienfiles "PgcEdit_backup"]
			if {$idx != -1} {
				set alienfiles [lreplace $alienfiles $idx $idx]
			}
			set idx [lsearch $alienfiles "VobBlanker_backup"]
			if {$idx != -1} {
				set alienfiles [lreplace $alienfiles $idx $idx]
			}
			foreach i $alienfiles {
				if {[string range $i 0 0] == "~"} {
					set idx [lsearch $alienfiles $i]
					set alienfiles [lreplace $alienfiles $idx $idx]
				}
			}
			if {[llength $alienfiles]>0} {
				set txt "ERROR: There are [llength $alienfiles] alien files in the VIDEO_TS folder:\n"
				set txt "${txt}[string map {\{ \" \} \"} $alienfiles]\n\n"
				set txt "${txt}Please remove them before burning the DVD.\n\n"
				set txt "${txt}Note: The PgcEdit_backup and VobBlanker_backup folders, and ~* backup files\nare automatically excluded.\n"
				set txt "${txt}You don't need to delete them."
				tk_messageBox -title "PgcEdit: Burn DVD" -icon error \
						-message $txt \
						-parent $w -type ok
				::macros::explore_dvd
				set error true
			}
		}

		# Verify if the user wants to burn eventual DVD-ROM files
		if {!$error} {
			set alienfiles [glob -tails -directory $in *]
			foreach f {VIDEO_TS AUDIO_TS JACKET_P} {
				set idx [lsearch $alienfiles $f]
				if {$idx != -1} {
					set alienfiles [lreplace $alienfiles $idx $idx]
				}
			}
			if {[llength $alienfiles]>0} {
				if {[llength $alienfiles]==1} {
					set msg "There is one DVD-ROM file (or subfolder) in the DVD root folder:\n[string map {\{ \" \} \"} $alienfiles]\n\nAre you sure you want to burn it as well?"
				} else {
					set msg "There are [llength $alienfiles] DVD-ROM files (or subfolders) in the DVD root folder:\n[string map {\{ \" \} \"} $alienfiles]\n\nAre you sure you want to burn them as well?"
				}
				set r [tk_messageBox -title "PgcEdit: Burn DVD" -icon warning \
						-message $msg -parent $w -type yesno -default no]
				if {$r == "no"} {
					::macros::explore_dvd parent
					set error true
				}
			}
		}

		# Create AUDIO_TS
		if {!$error} {
			catch {file mkdir "$in/AUDIO_TS"}
			if {![file isdirectory "$in/AUDIO_TS"]} {
				set msg "Warning: Cannot create AUDIO_TS folder!\n\nContinue anyway?"
				set r [tk_messageBox -title "PgcEdit: Burn DVD" -icon warning \
						-message $msg -parent $w -type yesno -default no]
				if {$r == "no"} {
					set error true
				}
			}
		}

		# verify ISO compatibility with mkisofs in -print-size mode
		if {!$error} {
			set txt "Generating ISO image.  Please wait..."
			set ::burn::status $txt
			show_msg "Burn DVD: $txt"
			update idletasks
			after 5 set ::burn::pause 1
			tkwait variable ::burn::pause
			catch {file delete $log}
			if [catch {set size [exec -- $::burn::mkisofspath -dvd-video -print-size -V $::burn::id -p PgcEdit -x PgcEdit_backup -x VobBlanker_backup -m ~* $in >& $log]} errstr] {
				show_msg "Burn DVD: $errstr"
				if [file exists $log] {
					bell
					set logout [log_header $in]
					set logout $logout[readLog $log]
					set logout "$logout\nError creating ISO:\n$errstr\n"
					::main::showtext .burnlog "PgcEdit Burn DVD - ISO creation log" $logout
					file delete $log
				} else {
					tk_messageBox -title "PgcEdit: Burn DVD" -icon error \
							-message "Error creating ISO:\n$errstr" -parent $w -type ok
				}
				set error 1
			}
		}

		# all preparation checks completed.  Return to input mode if error
		if $error continue

		# configure burn window for burning
		if {!$error} {			
			$w.fb.ok configure -state disabled
			$w.fb.cancel configure -state disabled
			$w.opts.f2.lab configure -foreground [$w.fb.ok cget -disabledforeground]
			$w.opts.f2.id configure -state disabled
			$w.opts.f2.browse configure -state disabled
			$w.opts.f1.lab configure -foreground [$w.fb.ok cget -disabledforeground]
			$w.opts.f1.id configure -state disabled
		}

		# Delete already existing ISO image
		if {!$error} {
			if {$::burn::splitoutput != ""} {
				for {set i 0} {$i < 100} {incr i} {
					set fname $out[format _%02d $i]
					if [file exists $fname] {
						catch {file delete $fname}
					} else {
						break
					}
				}
			}
			catch {file delete $realout}
		}

		# Launch Make ISO batch command
		if {!$error} {
			set ::burn::processing true
			catch {file delete $log}
			set bat [file normalize [file join $::config(tempdir) "MakeISO.bat"]]
			set cmd "@echo off\n"
			set cmd "${cmd}\"$::burn::mkisofspath\" -dvd-video -V \"$::burn::id\" -o \"$out\" -p PgcEdit -x PgcEdit_backup -x VobBlanker_backup -m ~* $::burn::splitoutput \"$in\" 2>&1\n"
			set cmd "${cmd}if errorlevel 1 echo $mkisofserror\n"
			saveFile $bat auto $cmd
			if [catch {set fh [open "|\"$bat\"" r]} errstr] {
				tk_messageBox -title "PgcEdit: Burn DVD" -icon error \
						-message $errstr -parent $w -type ok 
				set error true
			} else {
				$w.fb.cancel configure -text "Abort" -state normal -command {
							set ::burn::burn_done 0
							set ::burn::status "Aborting..."
							show_msg "Burn DVD: Aborting..."
							set ::burn::pause false
							update idletasks
							after 100 {set ::burn::pause true}
							tkwait variable ::burn::pause
						}
				wm protocol $w WM_DELETE_WINDOW {
							set ::burn::burn_done 0
							set ::burn::status "Aborting..."
							show_msg "Burn DVD: Aborting..."
							set ::burn::pause false
							update idletasks
							after 100 {set ::burn::pause true}
							tkwait variable ::burn::pause
						}
			}
		}

		# parse mkisofs output while it is running, and check for Abort
		set showlogout false
		set warnings false
		if {!$error} {
			set showlogout true
			set logout [log_header $in]
			set pc 0
			while {![eof $fh]} {
				# parse mkisofs output
				set line [gets $fh]
				if {[string first "% done, estimate finish" $line] >= 0} {
					set pc [string trim [string range $line 0 [string first "%" $line]] " %"]
					set ::burn::status "Generating ISO image: [string range $line 0 [string last " " $line]]"
					update_progresbar $w.c $pc
				} else {
					if {[string first "/cygdrive/" $line] != -1} {
						set warnings true
						set line [string trim [string map {"/cygdrive/" "\n/cygdrive/"} $line] \n]
						set idx1 [string first "/cygdrive/" $line]
						while {$idx1 >= 0} {
							set idx2 [string first "/mkisofs:" $line $idx1]
							incr idx2
							incr idx1 -1
							set line [string range $line 0 $idx1][string range $line $idx2 end]
							set idx1 [string first "/cygdrive/" $line]
						}
					}
					if {[string first "Unable" $line] != -1} {
						set warnings true
					}
					if {[string first "Can't" $line] != -1} {
						set warnings true
					}
					if {[string first "extents written" $line] >= 0} {
						set ::burn::status "Done."
						set pc 100
						update_progresbar $w.c 100
					}
					if {[string first "$mkisofserror" $line] >= 0} {
						set ::burn::status "$mkisofserror"
						set error true
					}
					set logout "${logout}$line\n"
					if {$line != ""} {
						set ::burn::status "$line"
					}
				}

				# allow screen refresh, and check if we need to abort
				set ::burn::pause false
				update idletasks
				after 15 {set ::burn::pause true}
				tkwait variable ::burn::pause
				if {$::burn::burn_done == 0} {
					set pid [pid $fh]
					catch {close $fh}
					catch {exec -- [file join $::config(bindir) pskill.exe] $pid}
					file delete $::burn::out
					set error true
					set logout "$logout\nAborted by user.\n"
					set ::burn::status "Aborted."
					show_msg "Burn DVD: Aborted."
					break
				}
			}
			if {$pc != 100} {
				set warnings true
			}
		}

		# close mkisofs output
		if {!$error} {
			set err [catch {close $fh} errstr]
			if {$err} {
				set logout "$logout\n$errstr\n"
				set error true
			} else {
				set logout "${logout}ISO created"
				if $warnings {
					set logout "${logout}, WITH WARNINGS!\n"
				} else {
					set logout "${logout} OK.\n"
				}
			}
		}

		# create the .LST file if option to split output is ON
		if {!$error && $::burn::splitoutput != ""} {
			set txt "IMAGELIST\n"
			for {set i 0} {$i < 100} {incr i} {
				set fname $out[format _%02d $i]
				if [file exists $fname] {
					set txt "${txt}$fname\n"
				} else {
					break
				}
			}
			saveFile $realout auto $txt
		}

		# delete ISO image in case of error
		if $error {
			if {$::burn::splitoutput != ""} {
				for {set i 0} {$i < 100} {incr i} {
					set fname $out[format _%02d $i]
					if [file exists $fname] {
						catch {file delete $fname}
					} else {
						break
					}
				}
			}
			catch {file delete $realout}
		}

		# show log if requested and in case of error
		if {$showlogout && ($::burn::showlog || $error || $warnings)} {
			if $error bell
			::main::showtext .burnlog "PgcEdit Burn DVD - ISO creation log" $logout
			after 500 {set ::burn::pause 1}
			tkwait variable ::burn::pause
		}
	}

	# mount image
	if {!$error && $::burn::mount && $::burn::splitoutput == ""} {
		set ::burn::status "ISO created OK!  Mounting ISO image..."
		show_msg "Burn DVD: ISO created OK! Mounting ISO image..."
		set cmd1 "\"$::burn::daemonpath\" -unmount $::burn::mount_device\n"
		set cmd2 "\"$::burn::daemonpath\" -mount $::burn::mount_device,\"$realout\"\n"
		set bat [file join $::config(tempdir) "MountISO.bat"]
		saveFile $bat auto $cmd1$cmd2
		if [catch {exec -- $bat &} errstr] {
			tk_messageBox -title "PgcEdit: Burn DVD" -icon error \
					-message "Daemon-Tools error:\n$errstr" \
					-parent $w -type ok
		} else {
			after 1000
			#catch {exec -- $::burn::daemonpath &}	;# show Daemon-Tools icon in tray
			if $::burn::burn {
				after 7000
			}
		}
	}

	# Burn using DVD Decrypter
	if {!$error && $::burn::burn} {
		set txt "ISO created OK!  Burning DVD..."
		set ::burn::status $txt
		show_msg "Burn DVD: $txt"
		update idletasks
		after 500 {set ::burn::pause 1}
		tkwait variable ::burn::pause
		if [catch {exec -- $::burn::dvddecrypterpath /MODE ISOWRITE $::burn::start $::burn::eraserw /SPEED $::burn::speed /VERIFY $::burn::verify $::burn::close $::burn::shutdown /DELETEIMAGE $::burn::deleteimage /SRC "$realout" /dest $::burn::burnerletter &} errstr] {
			tk_messageBox -title "PgcEdit: Burn DVD" -icon error \
					-message "DVD Decrypter error:\n$errstr" \
					-parent $w -type ok
			set error true
		}
	}

	# if Shutdown option is ON, exit PgcEdit.
	if {!$error && $::burn::burn && $::burn::shutdown == "/SHUTDOWN"} {
		show_msg "Burn DVD: Exiting PgcEdit."
		if {$::config(save_setups_on_exit)} {
			save_user_prefs
		}
		exit
	}

	# quit burn
	trace remove variable ::burn::out write ::burn::validate_burn
	trace remove variable ::burn::id  write ::burn::validate_burn
	set ::burn::processing false
	destroy $w
}

proc validate_burn {args} {
	set w .burn
	if {!$::burn::processing} {
		set ::burn::status "Ready."
	}
	if {![file isfile $::burn::dvddecrypterpath] || $::burn::burnerletter == ""} {
		if {![file isfile $::burn::dvddecrypterpath]} {
			set ::burn::status "Error in burn setup: DVD Decrypter.exe path not valid!"
		} else {
			set ::burn::status "Error in burn setup: DVD Burner drive letter not set!"
		}
		set ::burn::burn false
		$w.opts.burn configure -state disabled
	} else {
		$w.opts.burn configure -state normal
	}
	if $::burn::burn {
		set state normal
		$w.opts.bo.sp.l configure -foreground [$w.fb.ok cget -foreground]
	} else {
		set state disabled
		$w.opts.bo.sp.l configure -foreground [$w.fb.ok cget -disabledforeground]
	}
	$w.opts.bo.sp.speed configure -state $state
	$w.opts.bo.eraserw  configure -state $state
	$w.opts.bo.verify   configure -state $state
	$w.opts.bo.start    configure -state $state
	$w.opts.bo.close    configure -state $state
	$w.opts.bo.shutdown configure -state $state
	$w.opts.bo.del      configure -state $state
	if {![file isfile $::burn::mkisofspath]} {
		$w.fb.ok configure -state disabled
		set ::burn::status "Error in burn setup: mkisofs.exe path not valid!"
	} else {
		set extension [string toupper [file extension $::burn::out]]
		if {[file isdirectory [file dirname $::burn::out]] && \
				![file isdirectory $::burn::out] && \
				[string toupper [file tail $::burn::out]] != ".ISO" && \
				[file tail $::burn::out] != "" && \
				$extension == ".ISO" && \
				[string range $::burn::out end end] != "\\" && \
				[string range $::burn::out end end] != "/" && \
				$::burn::id != "" && ! $::burn::processing} {
			$w.fb.ok configure -state normal
		} else {
			if {![file isdirectory [file dirname $::burn::out]]} {
				set ::burn::status "Output ISO path not valid!"
			}
			if {$extension != ".ISO"} {
				set ::burn::status "Output ISO extension not valid!"
			}
			if {[file isdirectory $::burn::out] || \
					[string toupper [file tail $::burn::out]] == ".ISO" || \
					[file tail $::burn::out] == "" || \
					[string range $::burn::out end end] == "\\" || \
					[string range $::burn::out end end] == "/"} {
				set ::burn::status "Output ISO filename not valid!"
			}
			if {$::burn::id == ""} {
				set ::burn::status "Volume label empty!"
			}
			$w.fb.ok configure -state disabled
		}
	}
	
	if [file isfile $::burn::daemonpath] {
		$w.fb.dt configure -state normal
	} else {
		$w.fb.dt configure -state disabled
	}
	if {![file isfile $::burn::daemonpath] || $::burn::splitoutput != ""} {
		set ::burn::mount false
		$w.opts.fmount.mount configure -state disabled
	} else {
		$w.opts.fmount.mount configure -state normal
	}
	if {$::burn::mount} {
		$w.opts.fmount.device configure -state normal
		$w.opts.fmount.lab configure -foreground [$w.opts.fmount.device cget -foreground]
	} else {
		$w.opts.fmount.device configure -state disabled
		$w.opts.fmount.lab configure -foreground [$w.opts.fmount.device cget -disabledforeground]
	}
}


proc validate_id_entry {id} {
	if {$id==""} {
		return true
	}
	if {[string length $id]>32} {
		bell
		return false
	}
	if {[string is alnum $id]} {
		return true
	}
	for {set i 0} {$i < [string length $id]} {incr i} {
		set c [string range $id $i $i]
		if {[string first $c {/\\:~`*.;\"?<>#}] > -1} {
			bell
			return false
		}
	}
	return true
}

proc validate_publisher_entry {id} {
	if {[string length $id]>128} {
		bell
		return false
	}
	return true
}

proc log_header {inputdir} {
	set data "mkisofs log for DVD \"$::burn::id\"\nFrom: \"$inputdir\"\n"
	set data "${data}DVD-TEXT General Name: \"[::utils::get_General_Name]\"\n"
	set data "${data}Provider ID: \"[::utils::get_provider_ID]\"\n"
	set data "${data}Number of VTS: $::pgcs(numvts)\n"
	set data "${data}Output file: \"$::burn::out\"\n"
	set data "${data}Volume label: \"$::burn::id\"\n\n"
	return $data
}

proc readLog {logfile} {
	set errnum [catch {set in [open $logfile r]} err]
	if {$errnum} {
		errmsg $errnum "opening file for read" $err
		return
	}
	fconfigure $in -translation auto
	set warnings false
	set data ""
	while {! [eof $in]} {
		set errnum [catch {set line [gets $in]} err]
		if {$errnum} {
			errmsg $errnum "reading file" $err
		}
		if {[string first "% done, estimate finish" $line] == -1} {
			if {[string first "/cygdrive/" $line] != -1} {
				set warnings true
				set line [string trim [string map {"/cygdrive/" "\n/cygdrive/"} $line] \n]
				set idx1 [string first "/cygdrive/" $line]
				while {$idx1 >= 0} {
					set idx2 [string first "/mkisofs:" $line $idx1]
					incr idx2
					incr idx1 -1
					set line [string range $line 0 $idx1][string range $line $idx2 end]
					set idx1 [string first "/cygdrive/" $line]
				}
			}
			set data $data$line\n
		}
	}
	close $in
	return $data
}


proc update_progresbar {w pc} {
	if [info exists ::burn::progressbar_item] {
		$w delete $::burn::progressbar_item
	}
	set x [expr round((([winfo width $w]-5)/100.0)*$pc)]
	set ::burn::progressbar_item [$w create rectangle 0 0 $x 20 -fill blue]
}

proc save_setups {} {
	set txt "# PgcEdit Burn config file.  Saved automatically.  Do not edit!\n"
	set txt "${txt}\nset ::burn::mkisofspath [list $::burn::mkisofspath]"
	set txt "${txt}\nset ::burn::dvddecrypterpath [list $::burn::dvddecrypterpath]"
	set txt "${txt}\nset ::burn::daemonpath [list $::burn::daemonpath]"
	set txt "${txt}\nset ::burn::splitoutput [list $::burn::splitoutput]"
	set txt "${txt}\nset ::burn::burnerletter [list $::burn::burnerletter]"
	set txt "${txt}\n"
	saveFile [file join $::config(config_directory) ".burn.cfg"] auto $txt
}

proc dvd_rom_size {rootdir} {
	if [catch {set allfiles [glob -tails -directory $rootdir *]}] {
		return 0
	}
	foreach f {VIDEO_TS AUDIO_TS} {
		set idx [lsearch $allfiles $f]
		if {$idx != -1} {
			set allfiles [lreplace $allfiles $idx $idx]
		}
	}
	set sectors 0
	foreach f $allfiles {
		set filename [file join $rootdir $f]
		if {[file type $filename] == "file"} {
			incr sectors
			incr sectors [expr round(ceil([file size $filename]/2048.0))]
		} else {
			incr sectors 3
			incr sectors [dvd_rom_size_subdir $filename]
		}
	}
	return $sectors
}
proc dvd_rom_size_subdir {dir} {
	if [catch {set allfiles [glob -tails -directory $dir *]}] {
		return 0
	}
	set sectors 0
	foreach f $allfiles {
		set filename [file join $dir $f]
		if {[file type $filename] == "file"} {
			incr sectors
			incr sectors [expr round(ceil([file size $filename]/2048.0))]
		} else {
			incr sectors 3
			incr sectors [dvd_rom_size_subdir $filename]
		}
	}
	return $sectors
}

proc get_free_disk_space {path} {
	if [file exists $path] {
		if {[string toupper [file extension $path]] == ".ISO"} {
			set sectorsusedbyoldfile [expr [file size $path]/2048]
		} else {
			set rootname [file rootname $path]
			set sectorsusedbyoldfile 0
			for {set i 0} {$i < 100} {incr i} {
				set siso $rootname.ISO_[format %02d $i]
				if [file exists $siso] {
					incr sectorsusedbyoldfile [expr [file size $siso]/2048]
				} else {
					break
				}
			}
		}
	} else {
		set sectorsusedbyoldfile 0
	}
	set path [string toupper [string range [file nativename [file normalize $path]] 0 1]]
	if [catch {set txt [exec -- cmd.exe /c dir /-c $path]}] {return -1}
	set words [lreplace [split [string trim [lindex [split [string trim $txt \n] \n] end] " "]] 0 0]
	set free ""
	foreach w $words {
		if {$w != "" && [catch {set free [expr $w*1]}]==0} break
	}
	if {$free == ""} {return -1}
	set free [expr round(floor([expr $free/2048.0]))-$sectorsusedbyoldfile]

	# keep some free space on system disk for windows.
	set rootdir "C:"
	foreach i {C: D: E: F: G: H: I: J: K: L: M: N: O: P: Q: R: S: T: U: V: W: X: Y: Z:} {
		if [file exists $i] {
			set rootdir "$i"
			break
		}
	}
	if {$path == $rootdir} {
		incr free -51200
	} else {
		incr free -10240
	}
	return $free
}

}
}